# TODO
import nevergrad as ng
from cassandra.model.nevergrad.utils import instrum_transformations_nevergrad, create_df_transformations_nevergrad, \
    choose_optimizer_algoritm, optimize_metric
from cassandra.model.utils import choose_model



def nevergrad_model(df, hyperparameters_dict, medias, organic, target, use_adstock=True, use_saturation=True,
                    adstock_type='weibull', model_regression='linear', X_transformations_columns=[],
                    model_regression_log_log='linear', ridge_number=0, metric=['rsq', 'nrmse', 'mape'],
                    return_metric=True, size=0.2, positive=False, random_state=42, metric_return='mape',
                    force_coeffs=False, coeffs=[], intercept=0, optimizer_algoritm='TwoPointsDE', budget=1000):
    value_trasf = instrum_transformations_nevergrad(hyperparameters_dict)
    instrum = ng.p.Instrumentation(**value_trasf)
    optimizer = choose_optimizer_algoritm(optimizer_algoritm, budget, instrum)

    metric_array = []
    df_transformations = df.copy()
    metrics_values = {}
    all_hyper = list(hyperparameters_dict.keys())

    def build_model(**all_hyper):
        df_transf = create_df_transformations_nevergrad(all_hyper, df, df_transformations, medias, use_adstock,
                                                        use_saturation, adstock_type)

        #CHECK
        if 'ridge_number' in all_hyper:
            nonlocal ridge_number
            ridge_number = all_hyper['ridge_number']

        if force_coeffs:
            all_coeffs = [value for key, value in all_hyper.items() if '_spend_' not in key]
            nonlocal coeffs
            coeffs = all_coeffs[:-1]

            nonlocal intercept
            intercept = all_coeffs[-1]

        result, model, metrics_values = choose_model(df_transf, medias + organic, target, model_regression,
                                                     X_transformations_columns,
                                                     model_regression_log_log, ridge_number, metric,
                                                     return_metric, size, positive, random_state, force_coeffs,
                                                     coeffs, intercept)


        metric_to_optimize = optimize_metric(metric_return, metrics_values)
        metric_array.append(metric_to_optimize)

        return metric_to_optimize

    recommendation = optimizer.minimize(build_model)

    def build_model_result(**all_hyper):

        df_transf = create_df_transformations_nevergrad(all_hyper, df, df_transformations, medias, use_adstock,
                                                        use_saturation, adstock_type)

        result, model, metrics_values = choose_model(df_transf, medias + organic, target, model_regression,
                                                     X_transformations_columns,
                                                     model_regression_log_log, ridge_number, metric,
                                                     return_metric, size, positive, random_state, force_coeffs,
                                                     coeffs, intercept)


        metric_to_optimize = optimize_metric(metric_return, metrics_values)
        metric_array.append(metric_to_optimize)

        return metric_to_optimize, result, model

    metric, result, model = build_model_result(**recommendation.value[1])
    return metric, result, model, recommendation.value[1], metric_array
